SystemOrganization addCategory: #'Glamour-Browsers'!

GLMExplicitBrowser subclass: #GLMTableLayoutBrowser
	instanceVariableNames: 'cell'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Browsers'!

!GLMTableLayoutBrowser methodsFor: 'layout' stamp: ' 4/5/09 22:18'!
addColumn: aBlockOrSymbol 
	 
	^self cellOrRow addColumn: aBlockOrSymbol! !

!GLMTableLayoutBrowser methodsFor: 'layout' stamp: ' 4/5/09 22:18'!
addColumn: aBlockOrSymbol span: anInteger 
	 
	^(self addColumn: aBlockOrSymbol) span: anInteger! !

!GLMTableLayoutBrowser methodsFor: 'layout' stamp: ' 4/5/09 22:18'!
addRow: aBlockOrSymbol 
	 
	^self cellOrColumn addRow: aBlockOrSymbol! !

!GLMTableLayoutBrowser methodsFor: 'layout' stamp: ' 4/5/09 22:18'!
addRow: aBlockOrSymbol span: anInteger 
	 
	^(self addRow: aBlockOrSymbol) span: anInteger! !

!GLMTableLayoutBrowser methodsFor: 'layout' stamp: ' 4/5/09 22:18'!
cell 
	 
	^cell! !

!GLMTableLayoutBrowser methodsFor: 'private' stamp: ' 4/5/09 22:18'!
cellOrColumn 
	 
	^cell ifNil: [cell _ GLMCustomColumn new browser: self]! !

!GLMTableLayoutBrowser methodsFor: 'private' stamp: ' 4/5/09 22:18'!
cellOrRow 
	 
	^cell ifNil: [cell _ GLMCustomRow new browser: self]! !

!GLMTableLayoutBrowser methodsFor: 'scripting-private' stamp: ' 4/5/09 22:18'!
initializeScriptingDefaults 
	 
	super initializeScriptingDefaults. 
	self cell isNil ifTrue: [self addColumn: #pane]. 
	self jumpstartTransmissions isEmpty 
		ifTrue: 
			[self 
				addJumpstart: 
					((GLMBundleTransmission new) 
						destination: (self panes first port: #entity); 
						addPresentation: GLMFlexiblePresentation new; 
						yourself)]! !

!GLMTableLayoutBrowser methodsFor: 'rendering' stamp: ' 4/5/09 22:18'!
renderGlamorouslyOn: aRenderer 
	 
	^aRenderer renderTableLayoutBrowser: self! !

Announcement subclass: #GLMPaneAdded
	instanceVariableNames: 'pane browser position'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Browsers'!

!GLMPaneAdded classSide methodsFor: 'instance creation' stamp: ' 4/5/09 22:18'!
pane: aPane atPosition: anInteger inBrowser: aBrowser 
	 
	^(self new) 
		pane: aPane; 
		position: anInteger; 
		browser: aBrowser; 
		yourself! !

!GLMPaneAdded methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
browser 
	 
	^browser! !

!GLMPaneAdded methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
browser: anObject 
	 
	browser _ anObject! !

!GLMPaneAdded methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
pane 
	 
	^pane! !

!GLMPaneAdded methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
pane: anObject 
	 
	pane _ anObject! !

!GLMPaneAdded methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
position 
	 
	^position! !

!GLMPaneAdded methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
position: anObject 
	 
	position _ anObject! !

Announcement subclass: #GLMPaneRemoved
	instanceVariableNames: 'browser pane'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Browsers'!

!GLMPaneRemoved classSide methodsFor: 'instance creation' stamp: ' 4/5/09 22:18'!
pane: aPane fromBrowser: aBrowser 
	 
	^(self new) 
		pane: aPane; 
		browser: aBrowser; 
		yourself! !

!GLMPaneRemoved methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
browser 
	 
	^browser! !

!GLMPaneRemoved methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
browser: anObject 
	 
	browser _ anObject! !

!GLMPaneRemoved methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
pane 
	 
	^pane! !

!GLMPaneRemoved methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
pane: anObject 
	 
	pane _ anObject! !

GLMImplicitBrowser subclass: #GLMFinder
	instanceVariableNames: 'panes presentations transmissions scriptTransmission'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Browsers'!

!GLMFinder methodsFor: 'private' stamp: ' 4/5/09 22:18'!
addPaneFrom: aPort 
	 
	self panes 
		addLast: 
			((GLMPane new) 
				browser: self; 
				yourself). 
	(GLMBundleTransmission new) 
		addActiveOrigin: aPort; 
		destination: (self panes last port: #entity); 
		addPresentations: (self presentations collect: [:each | each copy]); 
		transmit. 
	self 
		announce: 
			(GLMPaneAdded 
				pane: self panes last 
				atPosition: self panes size 
				inBrowser: self)! !

!GLMFinder methodsFor: 'private' stamp: ' 4/5/09 22:18'!
addPaneFromInner: aPort 
	 
	| newTransmission realTransmissions | 
	self panes 
		addLast: 
			((GLMPane new) 
				browser: self; 
				yourself). 
	(GLMBundleTransmission new) 
		addActiveOrigin: aPort; 
		destination: (self panes last port: #entity); 
		addPresentations: (self presentations collect: [:each | each copy]); 
		transmit. 
	realTransmissions _ self transmissions 
		collect: 
			[:each |  
			newTransmission _ GLMBundleTransmission new. 
			each activeOrigins 
				do: 
					[:eachPort | newTransmission addActiveOrigin: (aPort pane port: eachPort name)]. 
			each passiveOrigins 
				do: 
					[:eachPort | newTransmission addPassiveOrigin: (aPort pane port: eachPort name)]. 
			newTransmission 
				destination: (self panes last port: #entity); 
				presentations: 
						(self presentations collect: #copy) , (each presentations collect: #copy)]. 
	(realTransmissions select: [:each | each originatesAt: aPort]) 
		do: [:each | each transmit]. 
	self 
		announce: 
			(GLMPaneAdded 
				pane: self panes last 
				atPosition: self panes size 
				inBrowser: self)! !

!GLMFinder methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
addPresentation: aPresentation 
	 
	self presentations addLast: aPresentation! !

!GLMFinder methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
addTransmission: aTransmission 
	 
	self transmissions addLast: aTransmission! !

!GLMFinder methodsFor: 'events' stamp: ' 4/5/09 22:18'!
innerPortEvent: aPortEvent 
	 
	aPortEvent portName = #entity 
		ifFalse: 
			["We don't want to resend the transmission, but use a new SimpleTransmission." 
			(self pane port: aPortEvent portName) value: aPortEvent value]. 
	aPortEvent port name = #selection 
		ifTrue: 
			[(self panes reverse copyUpTo: aPortEvent pane) 
				do: 
					[:each |  
					self panes removeLast. 
					self announce: (GLMPaneRemoved pane: each fromBrowser: self)]. 
			self addPaneFromInner: aPortEvent port]! !

!GLMFinder methodsFor: 'events' stamp: ' 4/5/09 22:18'!
outerPortEvent: aPortEvent 
	 
	aPortEvent port name = #entity ifFalse: [^self]. 
	panes _ nil. 
	self addPaneFrom: aPortEvent port! !

!GLMFinder methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
panes 
	 
	^panes ifNil: [panes _ OrderedCollection new]! !

!GLMFinder methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
presentations 
	 
	^presentations ifNil: [presentations _ OrderedCollection new]! !

!GLMFinder methodsFor: 'rendering' stamp: ' 4/5/09 22:18'!
renderGlamorouslyOn: aRenderer 
	 
	^aRenderer renderFinder: self! !

!GLMFinder methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
transmissions 
	 
	^transmissions ifNil: [transmissions _ OrderedCollection new]! !

GLMFinder subclass: #GLMFixedFinder
	instanceVariableNames: 'paneCount'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Browsers'!

!GLMFixedFinder methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
numberOfVisiblePanes 
	 
	^paneCount! !

!GLMFixedFinder methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
numberOfVisiblePanes: anInteger 
	 
	paneCount _ anInteger! !

Object subclass: #GLMCustomCell
	instanceVariableNames: 'children span id browser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Browsers'!

!GLMCustomCell methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
browser 
	 
	^browser! !

!GLMCustomCell methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
browser: anObject 
	 
	browser _ anObject! !

!GLMCustomCell methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
children 
	 
	^children ifNil: [children _ OrderedCollection new]! !

!GLMCustomCell methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
children: anObject 
	 
	children _ anObject! !

!GLMCustomCell methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
childrenCount 
	 
	^self children 
		inject: 0 
		into: [:sum :each | sum + each span]! !

!GLMCustomCell methodsFor: 'testing' stamp: ' 4/5/09 22:18'!
hasId 
	 
	^id notNil! !

!GLMCustomCell methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
id 
	 
	^id ifNil: [#anonymous]! !

!GLMCustomCell methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
id: anObject 
	 
	id _ anObject! !

!GLMCustomCell methodsFor: 'testing' stamp: ' 4/5/09 22:18'!
isColumn 
	 
	^false! !

!GLMCustomCell methodsFor: 'testing' stamp: ' 4/5/09 22:18'!
isRow 
	 
	^false! !

!GLMCustomCell methodsFor: 'testing' stamp: ' 4/5/09 22:18'!
isSplitIntoColumns 
	 
	^self children allSatisfy: [:each | each isColumn]! !

!GLMCustomCell methodsFor: 'testing' stamp: ' 4/5/09 22:18'!
isSplitIntoRows 
	 
	^self children allSatisfy: [:each | each isRow]! !

!GLMCustomCell methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
span 
	 
	^span ifNil: [span _ 1]! !

!GLMCustomCell methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
span: anObject 
	 
	span _ anObject! !

GLMCustomCell subclass: #GLMCustomColumn
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Browsers'!

!GLMCustomColumn methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
addRow: aBlockOrSymbol 
	 
	| newRow cell | 
	cell _ aBlockOrSymbol isSymbol 
		ifTrue: 
			[self browser 
				addPane: 
					((GLMPane new) 
						name: aBlockOrSymbol; 
						yourself). 
			(GLMCustomRow new) 
				id: aBlockOrSymbol; 
				browser: self browser] 
		ifFalse: 
			[newRow _ GLMCustomRow new browser: self browser. 
			aBlockOrSymbol value: newRow. 
			newRow]. 
	self children addLast: cell. 
	^cell! !

!GLMCustomColumn methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
addRow: aBlockOrSymbol span: anInteger 
	 
	^(self addRow: aBlockOrSymbol) span: anInteger! !

!GLMCustomColumn methodsFor: 'testing' stamp: ' 4/5/09 22:18'!
isColumn 
	 
	^true! !

GLMCustomCell subclass: #GLMCustomRow
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Browsers'!

!GLMCustomRow methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
addColumn: aBlockOrSymbol 
	 
	| newColumn cell | 
	cell _ aBlockOrSymbol isSymbol 
		ifTrue: 
			[self browser 
				addPane: 
					((GLMPane new) 
						name: aBlockOrSymbol; 
						yourself). 
			(GLMCustomColumn new) 
				id: aBlockOrSymbol; 
				browser: self browser] 
		ifFalse: 
			[newColumn _ GLMCustomColumn new browser: self browser. 
			aBlockOrSymbol value: newColumn. 
			newColumn]. 
	self children addLast: cell. 
	^cell! !

!GLMCustomRow methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
addColumn: aBlockOrSymbol span: anInteger 
	 
	^(self addColumn: aBlockOrSymbol) span: anInteger! !

!GLMCustomRow methodsFor: 'testing' stamp: ' 4/5/09 22:18'!
isRow 
	 
	^true! !
